## opm-common 2021.10

=== CMakeLists.txt ===
project(opm-common C CXX)
cmake_minimum_required (VERSION 3.10)

option(SIBLING_SEARCH "Search for other modules in sibling directories?" ON)
list(APPEND CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake/Modules)
set(OPM_MACROS_ROOT ${PROJECT_SOURCE_DIR})

option(ENABLE_ECL_INPUT "Enable eclipse input support?" ON)
option(ENABLE_ECL_OUTPUT "Enable eclipse output support?" ON)
option(ENABLE_MOCKSIM "Build the mock simulator for io testing" ON)
option(OPM_ENABLE_PYTHON "Enable python bindings?" OFF)
option(OPM_INSTALL_PYTHON "Enable python bindings?" OFF)
option(OPM_ENABLE_EMBEDDED_PYTHON "Enable embedded python?" OFF)

# Output implies input
if(ENABLE_ECL_OUTPUT)
  set(ENABLE_ECL_INPUT ON)
endif()

# And likewise, no input means no output
if(NOT ENABLE_ECL_INPUT)
  set(ENABLE_ECL_OUTPUT OFF)
endif()


# not the same location as most of the other projects; this hook overrides
macro (dir_hook)
endmacro (dir_hook)

# We need to define this variable in the installed cmake config file.
set(OPM_PROJECT_EXTRA_CODE_INSTALLED  "#ENABLE_ECL_INPUT is needed by opm-common-prereq.cmake
                                       set(ENABLE_ECL_INPUT ${ENABLE_ECL_INPUT})
                                       set(OPM_MACROS_ROOT ${CMAKE_INSTALL_PREFIX}/share/opm)
                                       list(APPEND CMAKE_MODULE_PATH \${OPM_MACROS_ROOT}/cmake/Modules)
                                       include(OpmPackage) #Make macros availabe after find_package(opm-common)")

set(OPM_PROJECT_EXTRA_CODE_INTREE "#ENABLE_ECL_INPUT is needed by opm-common-prereq.cmake
                                   set(ENABLE_ECL_INPUT ${ENABLE_ECL_INPUT})
                                   set(OPM_MACROS_ROOT ${OPM_MACROS_ROOT})
                                   list(APPEND CMAKE_MODULE_PATH \${OPM_MACROS_ROOT}/cmake/Modules)
                                   include(OpmPackage) #Make macros availabe after find_package(opm-common)")
if(ENABLE_ECL_OUTPUT)
  set(OPM_PROJECT_EXTRA_CODE_INSTALLED "${OPM_PROJECT_EXTRA_CODE_INSTALLED}
                                        set(COMPARE_ECL_COMMAND ${CMAKE_INSTALL_PREFIX}/bin${${name}_VER_DIR}/compareECL)
                                        set(OPM_PACK_COMMAND ${CMAKE_INSTALL_PREFIX}/bin${${name}_VER_DIR}/opmpack)
                                        set(RST_DECK_COMMAND ${CMAKE_INSTALL_PREFIX}/bin${${name}_VER_DIR}/rst_deck)")

  set(OPM_PROJECT_EXTRA_CODE_INTREE "${OPM_PROJECT_EXTRA_CODE_INTREE}
                                     set(COMPARE_ECL_COMMAND ${PROJECT_BINARY_DIR}/bin/compareECL)
                                     set(OPM_PACK_COMMAND ${PROJECT_BINARY_DIR}/bin/opmpack)
                                     set(RST_DECK_COMMAND ${PROJECT_BINARY_DIR}/bin/rst_deck)")
endif()

# project information is in dune.module. Read this file and set variables.
# we cannot generate dune.module since it is read by dunecontrol before
# the build starts, so it makes sense to keep the data there then.
include (OpmInit)
OpmSetPolicies()

# Look for the opm-tests repository; if found the variable
# HAVE_OPM_TESTS will be set to true.
include(Findopm-tests)

# list of prerequisites for this particular project; this is in a
# separate file (in cmake/Modules sub-directory) because it is shared
# with the find module
include (${project}-prereqs)

if(ENABLE_ECL_INPUT)
  # source_hook runs before config_hook and the former needs fmt, hence this
  # needs to be here.
  if(fmt_FOUND)
    # OpmSatellites will not add the library, do it here.
    list(APPEND opm-common_LIBRARIES fmt::fmt)
  else()
    add_definitions(-DFMT_HEADER_ONLY)
    include_directories(SYSTEM ${PROJECT_SOURCE_DIR}/external/fmtlib/include)
    # Not sure why this is needed.
    list(APPEND EXTRA_INCLUDES ${PROJECT_SOURCE_DIR}/external/fmtlib/include)
  endif()
endif()

# read the list of components from this file (in the project directory);
# it should set various lists with the names of the files to include
include (CMakeLists_files.cmake)

macro (config_hook)
  if(ENABLE_ECL_INPUT)
    if(NOT cjson_FOUND)
      list(APPEND EXTRA_INCLUDES ${PROJECT_SOURCE_DIR}/external/cjson)
    endif()

    # For this project
    include_directories(${EXTRA_INCLUDES} ${PROJECT_BINARY_DIR}/include)
    # For downstreams
    list(APPEND EXTRA_INCLUDES ${PROJECT_BINARY_DIR}/include)
    set(OPM_PROJECT_EXTRA_CODE_INTREE "${OPM_PROJECT_EXTRA_CODE_INTREE}
                                       list(APPEND opm-common_INCLUDE_DIRS ${EXTRA_INCLUDES})")
    if(ENABLE_ECL_INPUT)
      set(OPM_PROJECT_EXTRA_CODE_INTREE "${OPM_PROJECT_EXTRA_CODE_INTREE}
                                         set(HAVE_ECL_INPUT 1)")
      set(OPM_PROJECT_EXTRA_CODE_INSTALLED "${OPM_PROJECT_EXTRA_CODE_INSTALLED}
                                            set(HAVE_ECL_INPUT 1)")
    endif()
    if(ENABLE_ECL_OUTPUT)
      set(OPM_PROJECT_EXTRA_CODE_INTREE "${OPM_PROJECT_EXTRA_CODE_INTREE}
                                         set(HAVE_ECL_OUTPUT 1)")
      set(OPM_PROJECT_EXTRA_CODE_INSTALLED "${OPM_PROJECT_EXTRA_CODE_INSTALLED}
                                            set(HAVE_ECL_OUTPUT 1)")
    endif()

    find_package(Boost COMPONENTS filesystem regex system unit_test_framework)

    if (HAVE_DYNAMIC_BOOST_TEST)
      set_target_properties(Boost::unit_test_framework PROPERTIES INTERFACE_COMPILE_DEFINITIONS BOOST_TEST_DYN_LINK=1)
    endif()
  endif()
endmacro (config_hook)

macro (prereqs_hook)
endmacro (prereqs_hook)

macro (sources_hook)
  if(ENABLE_ECL_INPUT)
    # Keyword generation
    include(GenerateKeywords.cmake)

    # Append generated sources
    list(INSERT opm-common_SOURCES 0 ${PROJECT_BINARY_DIR}/ParserInit.cpp)
    foreach (name A B C D E F G H I J K L M N O P Q R S T U V W X Y Z)
        list(INSERT opm-common_SOURCES 0 ${PROJECT_BINARY_DIR}/ParserKeywords/${name}.cpp)
    endforeach()
    if (OPM_ENABLE_PYTHON)
      list(INSERT opm-common_SOURCES 0 ${PROJECT_BINARY_DIR}/python/cxx/builtin_pybind11.cpp)
    endif()
  endif()
  set_source_files_properties(src/opm/parser/eclipse/Python/Python.cpp
                              PROPERTIES COMPILE_FLAGS -Wno-shadow)
endmacro (sources_hook)

macro (fortran_hook)
endmacro (fortran_hook)

macro (files_hook)
endmacro (files_hook)

macro (tests_hook)
  if(ENABLE_ECL_INPUT)
    include(ExtraTests.cmake)
  endif()
endmacro (tests_hook)

macro (install_hook)
  install(DIRECTORY ${PROJECT_BINARY_DIR}/include/
          DESTINATION include
          PATTERN *.hpp)
endmacro (install_hook)

# If opm-common is configured to embed the python interpreter we must make sure
# that all downstream modules link libpython transitively. Due to the required
# integration with Python+cmake machinery provided by pybind11 this is done by
# manually adding to the opm-common_LIBRARIES variable here, and not in the
# OpmnLibMain function. Here only the library dependency is implemented, the
# bulk of the python configuration is further down in the file.
if (OPM_ENABLE_PYTHON)
  # We need to be compatible with older CMake versions
  # that do not offer FindPython3
  # e.g. Ubuntu LTS 18.04 uses cmake 3.10
  if(${CMAKE_VERSION} VERSION_LESS "3.12.0")
    find_package(PythonInterp REQUIRED)
    if (OPM_ENABLE_EMBEDDED_PYTHON)
      find_package(PythonLibs REQUIRED)
      list(APPEND opm-common_LIBRARIES ${PYTHON_LIBRARIES})
    endif()
    if(PYTHON_VERSION_MAJOR LESS 3)
      message(SEND_ERROR "OPM requires version 3 of Python but only version ${PYTHON_VERSION_STRING} was found")
    endif()
    set(Python3_EXECUTABLE ${PYTHON_EXECUTABLE})
    set(Python3_LIBRARIES ${PYTHON_LIBRARIES})
  else()
    # Be backwards compatible.
    if(PYTHON_EXECUTABLE AND NOT Python3_EXECUTABLE)
      set(Python3_EXECUTABLE ${PYTHON_EXECUTABLE})
    endif()
    if (OPM_ENABLE_EMBEDDED_PYTHON)
      find_package(Python3 REQUIRED COMPONENTS Interpreter Development)
      get_target_property(_lib_path Python3::Python IMPORTED_LOCATION)
      set(PYTHON_LIBRARY ${_lib_path})
      set(PYTHON_LIBRARIES {PYTHON_LIBRARY})
      list(APPEND opm-common_LIBRARIES ${PYTHON_LIBRARY})
      set(PYTHON_INCLUDE_DIRS ${Python3_INCLUDE_DIRS})
    else()
      find_package(Python3 REQUIRED COMPONENTS Interpreter)
    endif()
    # Compatibility settings for PythonInterp and PythonLibs
    # used e.g. in FindCwrap, pybind11
    set(PYTHON_EXECUTABLE ${Python3_EXECUTABLE})
  endif()
  # We always need the PYTHON_INCLUDE_DIR. Unfortunately
  # When we build pypi packages CMake will fail to determine
  # these via the usual find_package(PythonLibs or
  # find_package(Python3 REQUIRED COMPONENTS Interpreter Development)
  # Hence we overwrite them here.
  if(NOT PYTHON_INCLUDE_DIRS)
    execute_process(COMMAND "${PYTHON_EXECUTABLE}" "-c" "from distutils import sysconfig; print(sysconfig.get_python_inc(plat_specific=True), end=\"\");"
      RESULT_VARIABLE _PYTHON_DIR_SUCCESS
      OUTPUT_VARIABLE PYTHON_INCLUDE_DIR
      ERROR_VARIABLE _PYTHON_ERROR_VALUE)
    if(NOT _PYTHON_DIR_SUCCESS MATCHES 0)
      message(FATAL_ERROR "Could not determine Python include directory. Error: ${_PYTHON_ERROR_VALUE}.")
    endif()
    set(PYTHON_INCLUDE_DIRS ${PYTHON_INCLUDE_DIR})
  endif()
  find_package(pybind11 2.2 CONFIG)
  if (NOT pybind11_FOUND)
    # Use full path for reuse with pypi
    set(pybind11_INCLUDE_DIRS ${PROJECT_SOURCE_DIR}/python/pybind11/include ${PYTHON_INCLUDE_DIRS})
  endif()
endif()


# all setup common to the OPM library modules is done here
include (OpmLibMain)

if (ENABLE_MOCKSIM)
  add_library(mocksim
              msim/src/msim.cpp)
  target_link_libraries(mocksim opmcommon)
  target_include_directories(mocksim PUBLIC msim/include)
  add_executable(msim examples/msim.cpp)
  target_link_libraries(msim mocksim)

  if (Boost_UNIT_TEST_FRAMEWORK_FOUND)
    set(_libs mocksim opmcommon
      ${Boost_UNIT_TEST_FRAMEWORK_LIBRARY})

    foreach( test test_msim test_msim_ACTIONX test_msim_EXIT)
      opm_add_test(${test} SOURCES tests/msim/${test}.cpp
        LIBRARIES ${_libs}
        WORKING_DIRECTORY ${PROJECT_BINARY_DIR}/tests
        CONDITION ${HAVE_ECL_INPUT})
    endforeach()
  endif()
endif()

if (ENABLE_SCHEDULE_DEBUG)
  add_compile_definitions( SCHEDULE_DEBUG )
endif()

# Build the compare utilities
if(ENABLE_ECL_INPUT)
  add_executable(compareECL
    test_util/EclFilesComparator.cpp
    test_util/EclRegressionTest.cpp
    test_util/compareECL.cpp
    )

  add_executable(convertECL
    test_util/convertECL.cpp
    )

  add_executable(summary
    test_util/summary.cpp
    )

  add_executable(rewriteEclFile
    test_util/rewriteEclFile.cpp
    )

  foreach(target compareECL convertECL summary rewriteEclFile)
    target_link_libraries(${target} opmcommon)
    install(TARGETS ${target} DESTINATION bin)
  endforeach()

  # Add the tests
  set(_libs opmcommon
            ${Boost_UNIT_TEST_FRAMEWORK_LIBRARY})

  opm_add_test(test_EclFilesComparator
    CONDITION
      ENABLE_ECL_INPUT AND Boost_UNIT_TEST_FRAMEWORK_FOUND
    SOURCES
      tests/test_EclFilesComparator.cpp
      test_util/EclFilesComparator.cpp
    LIBRARIES
      ${_libs}
    WORKING_DIRECTORY
      ${PROJECT_BINARY_DIR}/tests
    )

  opm_add_test(test_EclRegressionTest
    CONDITION
      ENABLE_ECL_INPUT AND Boost_UNIT_TEST_FRAMEWORK_FOUND
    SOURCES
      tests/test_EclRegressionTest.cpp
      test_util/EclFilesComparator.cpp
      test_util/EclRegressionTest.cpp
    LIBRARIES
      ${_libs}
    WORKING_DIRECTORY
      ${PROJECT_BINARY_DIR}/tests
    )

  foreach(test test_EclIO test_EGrid test_ERft test_ERst test_ESmry test_EInit test_ExtESmry)
    opm_add_test(${test} CONDITION ENABLE_ECL_INPUT AND Boost_UNIT_TEST_FRAMEWORK_FOUND
                         LIBRARIES ${_libs}
                         WORKING_DIRECTORY ${PROJECT_BINARY_DIR}/tests)
  endforeach()
endif()

# Install build system files and documentation
install(DIRECTORY cmake
  DESTINATION share/opm USE_SOURCE_PERMISSIONS
  PATTERN "OPM-CMake.md" EXCLUDE)

install(FILES cmake/OPM-CMake.md

=== debian/changelog ===
opm-common (2021.10-3) unstable; urgency=medium

  * d/control: do not force g++ as compiler
  * d/control Build on any architecture even though we fail on 32bit.
  * d/tests/control: Allow autopkgtest only on 64bit hardware.

 -- Markus Blatt <markus@dr-blatt.de>  Mon, 24 Jan 2022 16:54:13 +0100

opm-common (2021.10-2) unstable; urgency=medium

  * d/patches: Support g++-11.2.0 and libfmt >=8.1.0
  * d/control: Move to standard version 4.6.0

 -- Markus Blatt <markus@dr-blatt.de>  Fri, 21 Jan 2022 18:37:22 +0100

opm-common (2021.10-1) unstable; urgency=medium

  * Initial release (Closes: #987381)

 -- Markus Blatt <markus@dr-blatt.de>  Tue, 16 Nov 2021 15:50:54 +0100

=== debian/control ===
Source: opm-common
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Arne Morten Kvarving <arne.morten.kvarving@sintef.no>, Markus Blatt <markus@dr-blatt.de>
Build-Depends: cmake (>=3.10), mpi-default-bin, mpi-default-dev,
               debhelper-compat (= 13), libcjson-dev, libfmt-dev, quilt, dh-python,
               pkg-config, git, libtool, doxygen, graphviz,
               texlive-latex-extra, texlive-latex-recommended,
               ghostscript, libboost-system-dev, libboost-test-dev,
               zlib1g-dev, python3-dev, libpython3-dev, python3-numpy, python3-distutils,
               python3-setuptools, python3-setuptools-scm, python3-pytest-runner,
               python3-decorator, libdune-common-dev, pybind11-dev
Standards-Version: 4.6.0
Section: libs
Homepage: http://opm-project.org
Vcs-Browser: https://salsa.debian.org/science-team/opm-common
Vcs-Git: https://salsa.debian.org/science-team/opm-common.git
Rules-Requires-Root: no

Package: libopm-common
Pre-Depends: ${misc:Pre-Depends}
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python3:Depends}
Provides: ${opm:shared-library}
Replaces: libopm-common1
Description: Tools for Eclipse reservoir simulation files -- library
 The Open Porous Media (OPM) software suite provides libraries and
 tools for modeling and simulation of porous media processes, especially
 for simulating CO2 sequestration and improved and enhanced oil recovery.
 .
 The Eclipse file format is widely used in the reservoir simulation
 community. This package provides library containing code for processing
 files in Eclipse format as well as utility code used by other OPM
 modules.

Package: libopm-common-bin
Pre-Depends: ${misc:Pre-Depends}
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}
Replaces: libopm-common1-bin
Description: Tools for Eclipse reservoir simulation files -- utility programs
 The Open Porous Media (OPM) software suite provides libraries and
 tools for modeling and simulation of porous media processes, especially
 for simulating CO2 sequestration and improved and enhanced oil recovery.
 .
 The Eclipse file format is widely used in the reservoir simulation
 community. This package provides utility programs to process files
 in this format, like for comparing two files, converting between
 binary version and formatted text file format, etc.

Package: libopm-common-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Suggests: libopm-common-doc
Replaces: libopm-common1-dev
Depends: ${opm:shared-library},  ${misc:Depends}, libcjson-dev, libfmt-dev,
         libboost-system-dev, libpython3-dev
Description: Tools for Eclipse reservoir simulation files -- development files
 The Open Porous Media (OPM) software suite provides libraries and
 tools for modeling and simulation of porous media processes, especially
 for simulating CO2 sequestration and improved and enhanced oil recovery.
 .
 This package contains the shared buildsystem of all OPM modules,
 the headers for input, parsing, and output of files in Eclipse format,
 a format widely used in the reservoir simulation community, and generic
 utilities used in other OPM modules.

Package: libopm-common-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Replaces: libopm-common1-doc
Depends: ${misc:Depends}
Description: Tools for Eclipse reservoir simulation files -- documentation
 The Open Porous Media (OPM) software suite provides libraries and
 tools for modeling and simulation of porous media processes, especially
 for simulating CO2 sequestration and improved and enhanced oil recovery.
 .
 This package contains the source code documentation of library and tools
 for Eclipse reservoir simulation files.

Package: python3-opm-common
Section: python
Pre-Depends: ${misc:Pre-Depends}
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python3:Depends}, libopm-common, python3-numpy, python3-decorator
Description: Tools for Eclipse reservoir simulation files -- Python wrappers
 The Open Porous Media (OPM) software suite provides libraries and
 tools for modeling and simulation of porous media processes,
 especially for simulating CO2 sequestration and improved and enhanced
 oil recovery.
 .
 This package contains the Python wrappers for reading, parsing, and
 writing files in Eclipse format, a format widely used in the
 reservoir simulation community.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

include /usr/share/dpkg/architecture.mk

OPM_DEBIAN_CMAKE_FLAGS = -DOPM_ENABLE_PYTHON=1 -DOPM_INSTALL_PYTHON=1 -DPYTHON_EXECUTABLE=/usr/bin/python3 -DOPM_INSTALL_COMPILED_PYTHON=OFF -DOPM_ENABLE_EMBEDDED_PYTHON=1



%:
	dh $@ --with python3

include debian/opm-debian.mk
include debian/opm-lib-debian.mk # for makeshlibs

=== debian/tests/control ===
Tests: basic
Depends:
  libdune-common-dev,
  libopm-common-dev,
  build-essential,
  mpi-default-bin, mpi-default-dev,
  libboost-test-dev
# Limit architectures to 64bit as we do not test successfully on 32bit
Architecture: amd64 arm64 ia64 mips64el ppc64el ia64 kfreebsd-amd64 ppc64 riscv64 sparc64
Restrictions: allow-stderr

=== debian/watch ===
# Compulsory line, this is a version 4 file
version=4

# PGP signature mangle, so foo.tar.gz has foo.tar.gz.sig
#opts="pgpsigurlmangle=s%$%.sig%"

# GitHub hosted projects
opts="filenamemangle=s%(?:.*?)?release/(\d\d\d\d\.\d\d)/final\.tar\.gz%opm-common-$1.tar.gz%,oversionmangle=s/(.*)/$1+ds/" \
   https://github.com/OPM/opm-common/tags \
   (?:.*?)?release/(\d\d\d\d\.\d\d)/final\.tar\.gz debian uupdate

# Direct Git
# opts="mode=git" http://git.example.com/opm-common.git \
#   refs/tags/v([\d\.]+) debian uupdate

## opm-common 2022.04+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -9,7 +9,7 @@
 option(ENABLE_ECL_OUTPUT "Enable eclipse output support?" ON)
 option(ENABLE_MOCKSIM "Build the mock simulator for io testing" ON)
 option(OPM_ENABLE_PYTHON "Enable python bindings?" OFF)
-option(OPM_INSTALL_PYTHON "Enable python bindings?" OFF)
+option(OPM_INSTALL_PYTHON "Install python bindings?" ON)
 option(OPM_ENABLE_EMBEDDED_PYTHON "Enable embedded python?" OFF)
 
 # Output implies input
@@ -80,6 +80,13 @@
   endif()
 endif()
 
+if(OPM_ENABLE_EMBEDDED_PYTHON AND NOT OPM_ENABLE_PYTHON)
+  # This needs to be here to run before source_hook
+  message(WARNING "Inconsistent settings: OPM_ENABLE_PYTHON=OFF and "
+    "OPM_ENABLE_EMBEDDED_PYTHON=ON. Please use OPM_ENABLE_PYTHON=ON to "
+    "activate. Will disable embedded python in this run.")
+  set(OPM_ENABLE_EMBEDDED_PYTHON OFF CACHE BOOL "Enable embedded python?" FORCE)
+endif()
 # read the list of components from this file (in the project directory);
 # it should set various lists with the names of the files to include
 include (CMakeLists_files.cmake)
@@ -130,11 +137,11 @@
     foreach (name A B C D E F G H I J K L M N O P Q R S T U V W X Y Z)
         list(INSERT opm-common_SOURCES 0 ${PROJECT_BINARY_DIR}/ParserKeywords/${name}.cpp)
     endforeach()
-    if (OPM_ENABLE_PYTHON)
+    if (OPM_ENABLE_EMBEDDED_PYTHON)
       list(INSERT opm-common_SOURCES 0 ${PROJECT_BINARY_DIR}/python/cxx/builtin_pybind11.cpp)
     endif()
   endif()
-  set_source_files_properties(src/opm/parser/eclipse/Python/Python.cpp
+  set_source_files_properties(src/opm/input/eclipse/Python/Python.cpp
                               PROPERTIES COMPILE_FLAGS -Wno-shadow)
 endmacro (sources_hook)
 
@@ -192,6 +199,18 @@
     else()
       find_package(Python3 REQUIRED COMPONENTS Interpreter)
     endif()
+    # Make sure we fail gracefully here without setuptool
+    execute_process(COMMAND ${Python3_EXECUTABLE} -c "import setuptools"
+      WORKING_DIRECTORY ${PROJECT_BINARY_DIR}
+      ERROR_VARIABLE SETUPTOOL_ERROR OUTPUT_VARIABLE SETUPTOOL_OUT
+      RESULT_VARIABLE SETUPTOOL_RESULT)
+    if(SETUPTOOL_RESULT GREATER 0)
+      message(WARNING "Trying to test setuptools resulted in error message: ${SETUPTOOL_ERROR}")
+      message(SEND_ERROR "To build the python bindings you need to install setuptool. "
+        "Either use \"apt-get install python3-setuptools\" (on Debian/Ubuntu) "
+        "or \"pip install setuptools\"")
+    endif()
+
     # Compatibility settings for PythonInterp and PythonLibs
     # used e.g. in FindCwrap, pybind11
     set(PYTHON_EXECUTABLE ${Python3_EXECUTABLE})
@@ -243,10 +262,6 @@
   endif()
 endif()
 
-if (ENABLE_SCHEDULE_DEBUG)
-  add_compile_definitions( SCHEDULE_DEBUG )
-endif()
-
 # Build the compare utilities
 if(ENABLE_ECL_INPUT)
   add_executable(compareECL
@@ -263,11 +278,15 @@
     test_util/summary.cpp
     )
 
+  add_executable(arraylist
+    test_util/arraylist.cpp
+    )
+
   add_executable(rewriteEclFile
     test_util/rewriteEclFile.cpp
     )
 
-  foreach(target compareECL convertECL summary rewriteEclFile)
+  foreach(target compareECL convertECL summary rewriteEclFile arraylist)
     target_link_libraries(${target} opmcommon)
     install(TARGETS ${target} DESTINATION bin)
   endforeach()
@@ -278,39 +297,3 @@
 
   opm_add_test(test_EclFilesComparator
     CONDITION
-      ENABLE_ECL_INPUT AND Boost_UNIT_TEST_FRAMEWORK_FOUND
-    SOURCES
-      tests/test_EclFilesComparator.cpp
-      test_util/EclFilesComparator.cpp
-    LIBRARIES
-      ${_libs}
-    WORKING_DIRECTORY
-      ${PROJECT_BINARY_DIR}/tests
-    )
-
-  opm_add_test(test_EclRegressionTest
-    CONDITION
-      ENABLE_ECL_INPUT AND Boost_UNIT_TEST_FRAMEWORK_FOUND
-    SOURCES
-      tests/test_EclRegressionTest.cpp
-      test_util/EclFilesComparator.cpp
-      test_util/EclRegressionTest.cpp
-    LIBRARIES
-      ${_libs}
-    WORKING_DIRECTORY
-      ${PROJECT_BINARY_DIR}/tests
-    )
-
-  foreach(test test_EclIO test_EGrid test_ERft test_ERst test_ESmry test_EInit test_ExtESmry)
-    opm_add_test(${test} CONDITION ENABLE_ECL_INPUT AND Boost_UNIT_TEST_FRAMEWORK_FOUND
-                         LIBRARIES ${_libs}
-                         WORKING_DIRECTORY ${PROJECT_BINARY_DIR}/tests)
-  endforeach()
-endif()
-
-# Install build system files and documentation
-install(DIRECTORY cmake
-  DESTINATION share/opm USE_SOURCE_PERMISSIONS
-  PATTERN "OPM-CMake.md" EXCLUDE)
-
-install(FILES cmake/OPM-CMake.md

=== debian/changelog ===
opm-common (2022.04+ds-2build1) kinetic; urgency=medium

  * No-change rebuild against libfmt9

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 21 Aug 2022 06:06:59 +0000

opm-common (2022.04+ds-2) unstable; urgency=medium

  * Changed version in dune.module to 2022.04

 -- Markus Blatt <markus@dr-blatt.de>  Thu, 12 May 2022 14:18:59 +0200

opm-common (2022.04+ds-1) unstable; urgency=medium

  * New final upstream version 2022.04
  * d/watch: Added dversionmangle option for repackaged tarball

 -- Markus Blatt <markus@dr-blatt.de>  Wed, 11 May 2022 22:46:25 +0200

opm-common (2022.04~rc1-2) experimental; urgency=medium

  * Make not finding Quadmath non-fatal (e.g. not available on arm64)

 -- Markus Blatt <markus@dr-blatt.de>  Fri, 29 Apr 2022 09:28:26 +0200

opm-common (2022.04~rc1-1) experimental; urgency=medium

  * New upstream release candidate 2022.04-rc1
  * Rediff patches
  * make new program arraylist part of libopm-common-bin.
  * d/copyright: Fix lintian warning "superfluous-file-pattern ./*"
  * d/control: Use debhelper-compat=12 to support older Ubuntu .
  * Spelling fixes (valied -> valid).
  * d/tests: Do not limit architectures but skip not installable

 -- Markus Blatt <markus@dr-blatt.de>  Wed, 27 Apr 2022 23:01:13 +0200

opm-common (2021.10-4) unstable; urgency=medium

  * d/tests: Make opm-autopkgtest script strip superfluous libraries

 -- Markus Blatt <markus@dr-blatt.de>  Mon, 25 Apr 2022 17:15:12 +0200

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,10 @@
 Source: opm-common
 Priority: optional
-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Arne Morten Kvarving <arne.morten.kvarving@sintef.no>, Markus Blatt <markus@dr-blatt.de>
 Build-Depends: cmake (>=3.10), mpi-default-bin, mpi-default-dev,
-               debhelper-compat (= 13), libcjson-dev, libfmt-dev, quilt, dh-python,
+               debhelper-compat (= 12), libcjson-dev, libfmt-dev, quilt, dh-python,
                pkg-config, git, libtool, doxygen, graphviz,
                texlive-latex-extra, texlive-latex-recommended,
                ghostscript, libboost-system-dev, libboost-test-dev,

=== debian/tests/control ===
Tests: basic
Depends:
  libdune-common-dev,
  libopm-common-dev,
  build-essential,
  mpi-default-bin, mpi-default-dev,
  libboost-test-dev
Restrictions: allow-stderr, skip-not-installable

## opm-common 2022.10%2Bds

=== debian/rules ===
--- 
+++ 
@@ -7,10 +7,14 @@
 
 OPM_DEBIAN_CMAKE_FLAGS = -DOPM_ENABLE_PYTHON=1 -DOPM_INSTALL_PYTHON=1 -DPYTHON_EXECUTABLE=/usr/bin/python3 -DOPM_INSTALL_COMPILED_PYTHON=OFF -DOPM_ENABLE_EMBEDDED_PYTHON=1
 
-
+need_gb_ram_per_process=3
+free_ram=$(shell free -g | sed -n 2p| sed "s/ \+/ /g"| cut -d " " -f 2)
+max_procs=$(shell echo "$(free_ram)/$(need_gb_ram_per_process)" | bc)
+parallel_procs=$(shell if test "$(max_procs)" -lt "1"; then echo 1; else echo "$(max_procs)"; fi)
 
 %:
-	dh $@ --with python3
+	echo "ram in gb: $(free_ram), needed ram per thread: $(need_gb_ram_per_process), threads: $(parallel_procs)"
+	dh $@ --with python3 --max-parallel=$(parallel_procs)
 
 include debian/opm-debian.mk
 include debian/opm-lib-debian.mk # for makeshlibs

## opm-common 2022.10+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -32,13 +32,13 @@
                                        set(ENABLE_ECL_INPUT ${ENABLE_ECL_INPUT})
                                        set(OPM_MACROS_ROOT ${CMAKE_INSTALL_PREFIX}/share/opm)
                                        list(APPEND CMAKE_MODULE_PATH \${OPM_MACROS_ROOT}/cmake/Modules)
-                                       include(OpmPackage) #Make macros availabe after find_package(opm-common)")
+                                       include(OpmPackage) #Make macros available after find_package(opm-common)")
 
 set(OPM_PROJECT_EXTRA_CODE_INTREE "#ENABLE_ECL_INPUT is needed by opm-common-prereq.cmake
                                    set(ENABLE_ECL_INPUT ${ENABLE_ECL_INPUT})
                                    set(OPM_MACROS_ROOT ${OPM_MACROS_ROOT})
                                    list(APPEND CMAKE_MODULE_PATH \${OPM_MACROS_ROOT}/cmake/Modules)
-                                   include(OpmPackage) #Make macros availabe after find_package(opm-common)")
+                                   include(OpmPackage) #Make macros available after find_package(opm-common)")
 if(ENABLE_ECL_OUTPUT)
   set(OPM_PROJECT_EXTRA_CODE_INSTALLED "${OPM_PROJECT_EXTRA_CODE_INSTALLED}
                                         set(COMPARE_ECL_COMMAND ${CMAKE_INSTALL_PREFIX}/bin${${name}_VER_DIR}/compareECL)
@@ -136,6 +136,7 @@
     list(INSERT opm-common_SOURCES 0 ${PROJECT_BINARY_DIR}/ParserInit.cpp)
     foreach (name A B C D E F G H I J K L M N O P Q R S T U V W X Y Z)
         list(INSERT opm-common_SOURCES 0 ${PROJECT_BINARY_DIR}/ParserKeywords/${name}.cpp)
+        list(INSERT opm-common_HEADERS 0 ${PROJECT_BINARY_DIR}/include/opm/input/eclipse/Parser/ParserKeywords/${name}.hpp)
     endforeach()
     if (OPM_ENABLE_EMBEDDED_PYTHON)
       list(INSERT opm-common_SOURCES 0 ${PROJECT_BINARY_DIR}/python/cxx/builtin_pybind11.cpp)
@@ -162,6 +163,14 @@
           DESTINATION include
           PATTERN *.hpp)
 endmacro (install_hook)
+
+# Used to append entries from one list to another.
+# The output list is suitable for use in setup.py subtitution
+macro(append_quoted OUT IN)
+  foreach(ENTRY ${${IN}})
+    list(APPEND ${OUT} "'${ARGN}${ENTRY}'")
+  endforeach()
+endmacro()
 
 # If opm-common is configured to embed the python interpreter we must make sure
 # that all downstream modules link libpython transitively. Due to the required
@@ -184,6 +193,8 @@
     endif()
     set(Python3_EXECUTABLE ${PYTHON_EXECUTABLE})
     set(Python3_LIBRARIES ${PYTHON_LIBRARIES})
+    set(Python3_VERSION "${PYTHON_VERSION_STRING}")
+    set(Python3_VERSION_MINOR ${PYTHON_VERSION_MINOR})
   else()
     # Be backwards compatible.
     if(PYTHON_EXECUTABLE AND NOT Python3_EXECUTABLE)
@@ -210,10 +221,21 @@
         "Either use \"apt-get install python3-setuptools\" (on Debian/Ubuntu) "
         "or \"pip install setuptools\"")
     endif()
+    if(Python3_VERSION_MINOR LESS 3)
+      # Python native namespace packages requires python >= 3.3
+      message(SEND_ERROR "OPM requires python >= 3.3 but only version ${Python3_VERSION} was found")
+    endif()
 
     # Compatibility settings for PythonInterp and PythonLibs
     # used e.g. in FindCwrap, pybind11
     set(PYTHON_EXECUTABLE ${Python3_EXECUTABLE})
+    # Directory to install common (for opm modules) python scripts
+    include (GNUInstallDirs)
+    set(OPM_PYTHON_COMMON_DIR "${CMAKE_INSTALL_DATAROOTDIR}/opm/python")
+    set(OPM_PROJECT_EXTRA_CODE_INTREE "${OPM_PROJECT_EXTRA_CODE_INTREE}
+                                       set(opm-common_PYTHON_COMMON_DIR ${PROJECT_SOURCE_DIR}/python)")
+    set(OPM_PROJECT_EXTRA_CODE_INSTALLED "${OPM_PROJECT_EXTRA_CODE_INSTALLED}
+                                         set(opm-common_PYTHON_COMMON_DIR ${CMAKE_INSTALL_PREFIX}/${OPM_PYTHON_COMMON_DIR})")
   endif()
   # We always need the PYTHON_INCLUDE_DIR. Unfortunately
   # When we build pypi packages CMake will fail to determine
@@ -247,53 +269,3 @@
   target_link_libraries(mocksim opmcommon)
   target_include_directories(mocksim PUBLIC msim/include)
   add_executable(msim examples/msim.cpp)
-  target_link_libraries(msim mocksim)
-
-  if (Boost_UNIT_TEST_FRAMEWORK_FOUND)
-    set(_libs mocksim opmcommon
-      ${Boost_UNIT_TEST_FRAMEWORK_LIBRARY})
-
-    foreach( test test_msim test_msim_ACTIONX test_msim_EXIT)
-      opm_add_test(${test} SOURCES tests/msim/${test}.cpp
-        LIBRARIES ${_libs}
-        WORKING_DIRECTORY ${PROJECT_BINARY_DIR}/tests
-        CONDITION ${HAVE_ECL_INPUT})
-    endforeach()
-  endif()
-endif()
-
-# Build the compare utilities
-if(ENABLE_ECL_INPUT)
-  add_executable(compareECL
-    test_util/EclFilesComparator.cpp
-    test_util/EclRegressionTest.cpp
-    test_util/compareECL.cpp
-    )
-
-  add_executable(convertECL
-    test_util/convertECL.cpp
-    )
-
-  add_executable(summary
-    test_util/summary.cpp
-    )
-
-  add_executable(arraylist
-    test_util/arraylist.cpp
-    )
-
-  add_executable(rewriteEclFile
-    test_util/rewriteEclFile.cpp
-    )
-
-  foreach(target compareECL convertECL summary rewriteEclFile arraylist)
-    target_link_libraries(${target} opmcommon)
-    install(TARGETS ${target} DESTINATION bin)
-  endforeach()
-
-  # Add the tests
-  set(_libs opmcommon
-            ${Boost_UNIT_TEST_FRAMEWORK_LIBRARY})
-
-  opm_add_test(test_EclFilesComparator
-    CONDITION

=== debian/changelog ===
opm-common (2022.10+ds-7) unstable; urgency=medium

  * d/control: Limit the architectures to known working ones.

 -- Markus Blatt <markus@dr-blatt.de>  Thu, 23 Mar 2023 08:34:59 +0100

opm-common (2022.10+ds-6) unstable; urgency=medium

  * Reduce compile time and resources with g++-12
  * d: Fixed version string used in binaries.

 -- Markus Blatt <markus@dr-blatt.de>  Wed, 08 Mar 2023 23:05:15 +0100

opm-common (2022.10+ds-5) experimental; urgency=medium

  * Backported fixes for python tests from upstream (to fix mipsel*?)
  * d/rules: Try to limit parallel builds to ensure 3GB RAM per process

 -- Markus Blatt <markus@dr-blatt.de>  Sun, 05 Feb 2023 13:59:47 +0100

opm-common (2022.10+ds-4) unstable; urgency=medium

  * Make sure copy_python is run before CopyHeaders Closes: #1029440

 -- Markus Blatt <markus@dr-blatt.de>  Sat, 28 Jan 2023 21:44:01 +0100

opm-common (2022.10+ds-3) unstable; urgency=medium

  * Upload to unstable
  * Bump standards version to 4.6.2

 -- Markus Blatt <markus@dr-blatt.de>  Fri, 13 Jan 2023 14:46:07 +0100

opm-common (2022.10+ds-2) experimental; urgency=medium

  * Bump standards version to 4.6.1
  * Made FindAlberta compliant for using OPM packages as DUNE 2.9 packages.

 -- Markus Blatt <markus@dr-blatt.de>  Mon, 09 Jan 2023 09:35:20 +0100

opm-common (2022.10+ds-1) unstable; urgency=medium

  * New upstream version 2022.10
  * [reprobuild] Prevent built timestamps in programs
  * d/tests: Bump version dependency to current version.

 -- Markus Blatt <markus@dr-blatt.de>  Tue, 15 Nov 2022 15:39:10 +0100

opm-common (2022.10~rc2+ds-1) experimental; urgency=medium

  * New upstream release candidate 2022.10-rc1
  * d/tests: depend on same version of packages for autopkgtest.

 -- Markus Blatt <markus@dr-blatt.de>  Tue, 08 Nov 2022 20:24:53 +0100

opm-common (2022.10~rc1+ds-1) experimental; urgency=medium

  * New upstream release candidate 2022.10-rc1
  * Updated patches for new version
  * d: Mark copied python files as not to be installed.

 -- Markus Blatt <markus@dr-blatt.de>  Fri, 04 Nov 2022 09:27:22 +0100

=== debian/control ===
--- 
+++ 
@@ -1,17 +1,16 @@
 Source: opm-common
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Arne Morten Kvarving <arne.morten.kvarving@sintef.no>, Markus Blatt <markus@dr-blatt.de>
-Build-Depends: cmake (>=3.10), mpi-default-bin, mpi-default-dev,
+Build-Depends: cmake (>=3.10), mpi-default-bin, mpi-default-dev, bc, procps,
                debhelper-compat (= 12), libcjson-dev, libfmt-dev, quilt, dh-python,
-               pkg-config, git, libtool, doxygen, graphviz,
+               pkg-config, lsb-release, libtool, doxygen, graphviz,
                texlive-latex-extra, texlive-latex-recommended,
                ghostscript, libboost-system-dev, libboost-test-dev,
                zlib1g-dev, python3-dev, libpython3-dev, python3-numpy, python3-distutils,
                python3-setuptools, python3-setuptools-scm, python3-pytest-runner,
                python3-decorator, libdune-common-dev, pybind11-dev
-Standards-Version: 4.6.0
+Standards-Version: 4.6.2
 Section: libs
 Homepage: http://opm-project.org
 Vcs-Browser: https://salsa.debian.org/science-team/opm-common
@@ -20,7 +19,7 @@
 
 Package: libopm-common
 Pre-Depends: ${misc:Pre-Depends}
-Architecture: any
+Architecture: amd64 arm64 armel ia64 m68k mips64el mipsel ppc64el riscv64
 Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}, ${python3:Depends}
 Provides: ${opm:shared-library}
@@ -37,7 +36,7 @@
 
 Package: libopm-common-bin
 Pre-Depends: ${misc:Pre-Depends}
-Architecture: any
+Architecture: amd64 arm64 armel ia64 m68k mips64el mipsel ppc64el riscv64
 Multi-Arch: foreign
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Replaces: libopm-common1-bin
@@ -53,7 +52,7 @@
 
 Package: libopm-common-dev
 Section: libdevel
-Architecture: any
+Architecture: amd64 arm64 armel ia64 m68k mips64el mipsel ppc64el riscv64
 Multi-Arch: same
 Suggests: libopm-common-doc
 Replaces: libopm-common1-dev
@@ -86,7 +85,7 @@
 Package: python3-opm-common
 Section: python
 Pre-Depends: ${misc:Pre-Depends}
-Architecture: any
+Architecture: amd64 arm64 armel ia64 m68k mips64el mipsel ppc64el riscv64
 Depends: ${shlibs:Depends}, ${misc:Depends}, ${python3:Depends}, libopm-common, python3-numpy, python3-decorator
 Description: Tools for Eclipse reservoir simulation files -- Python wrappers
  The Open Porous Media (OPM) software suite provides libraries and

=== debian/tests/control ===
Tests: basic
Depends:
  libdune-common-dev,
  libopm-common-dev (>= 2022.10),
  build-essential,
  mpi-default-bin, mpi-default-dev,
  libboost-test-dev
Restrictions: allow-stderr, skip-not-installable

=== debian/watch ===
--- 
+++ 
@@ -5,7 +5,7 @@
 #opts="pgpsigurlmangle=s%$%.sig%"
 
 # GitHub hosted projects
-opts="filenamemangle=s%(?:.*?)?release/(\d\d\d\d\.\d\d)/final\.tar\.gz%opm-common-$1.tar.gz%,oversionmangle=s/(.*)/$1+ds/" \
+opts="filenamemangle=s%(?:.*?)?release/(\d\d\d\d\.\d\d)/final\.tar\.gz%opm-common-$1.tar.gz%,oversionmangle=s/(.*)/$1+ds/,dversionmangle=s/\+(debian|dfsg|ds|deb)(\.?\d+)?$//" \
    https://github.com/OPM/opm-common/tags \
    (?:.*?)?release/(\d\d\d\d\.\d\d)/final\.tar\.gz debian uupdate
